//Подключение библиотеки I2C шины.
#include <Wire.h>
//Подключение библиотеки удаленного управления.
#include "IRremote.h"
//Подключение библиотеки управления моторами.
#include "motor.h"
//Подключение библиотеки управления гироскопом.
#include "gyro_acsel.h"
// Порт для IR-приемника.
int RECV_PIN = 12;
// Создание IR-приемника.
IRrecv irrecv(RECV_PIN);
//Переменная для результатов IR-приемника.
decode_results results;
//========================================
// Опишем коды кнопок пульта макроподстановками:
#define STR_FORWARD 0x511DBB
#define STR_LEFT 0x52A3D41F
#define STR_RIGHT 0x20FE4DBB
#define STR_DOWN 0xA3C8EDDB
#define BUTTON_OK 0xD7E84B1B
#define BUTTON_1 0xC101E57B
#define BUTTON_2 0x97483BFB
#define BUTTON_3 0xF0C41643
#define BUTTON_4 0x9716BE3F
#define BUTTON_5 0x3D9AE3F7
#define BUTTON_6 0x6182021B
#define BUTTON_7  0x8C22657B
#define BUTTON_8 0x488F3CBB
#define BUTTON_9 0x449E79F
#define BUTTON_0 0x1BC0157B
#define BUTTON_STAR 0x32C6FDF7
#define BUTTON_ARRAY 0x3EC3FC1B
//========================================
void setup()
{
  Serial.begin(9600);
  //запуск гироскопа.
  giroscop_setup();
  // Переменные – номера контактов (пинов) Arduino.
  // Для левых и правых моторов машинки.
  setup_motor_system(3, 4, 11, 7, 8, 10);
  _stop(); //Двигатели остановлены.
  // Запуск IR-приемника.
  //Расчет компенсации утечки нуля гироскопа.
  delay(1000);
  //Находим величину дрейфа нуля осей гироскопа.
  Calc_CompensatorZ(3000);
  //Включаем прием IR-команд.
  irrecv.enableIRIn();
  Serial.print(" Start ");
  Ang_ = 0;
  _stop(); //Двигатели остановлены.
  setspeed(255, 255);
}
//=====================================
// Основная программа.
void loop()
{

  while (true)
  {
    // delay(30000);
    if (irrecv.decode(&results))
    {
      //  Serial.println(results.value, HEX);
      switch (results.value) {
        case STR_FORWARD:
          // Ехать вперед 5 секунд (5000000 микросекунд)
          forward_t(5000000);
          break;
        case STR_LEFT:
          // Повернуть влево на 5 градусов (разворот)
          Angle(5);
          break;
        case STR_RIGHT:
          // Повернуть вправо на 5 градусов (разворот)
          Angle(-5);
          break;
        case STR_DOWN:
          // Ехать назад 5 секунд (5000000 микросекунд)
          backward_t(5000000);
          break;
        case BUTTON_OK:
          // Держать угол 10 секунд
          Angle_t(10000000);
          break;
        case BUTTON_1:
          // Повернуть влево на 10 градусов
          Angle(10);
          break;
        case BUTTON_2:
          // Повернуть вправо на 90 градусов
          Angle(-90);
          break;
        case BUTTON_3:
          // Повернуть вправо на 10 градусов
          Angle(-10);
          break;
        case BUTTON_4:
          // Повернуть влево на 20 градусов
          Angle(20);
          break;
        case BUTTON_5:
          // Повернуть влево на 180 градусов
          Angle(180);
          break;
        case BUTTON_6:
          // Повернуть вправо на 20 градусов
          Angle(-20);
          break;
        case BUTTON_7:
          // Повернуть влево на 60 градусов
          Angle(60);
          break;
        case BUTTON_8:
          // Повернуть влево на 90 градусов
          Angle(90);
          break;
        case BUTTON_9:
          // Повернуть вправо на 60 градусов
          Angle(-60);
          break;
        case BUTTON_0:
          // Ехать назад 2 секунды
         backward_t(2000000);
          break;
        case BUTTON_STAR:
          //Держать угол 10 секунд
          Angle_t(10000000);
          break;
        case BUTTON_ARRAY:
          //Держать угол 5 секунд
          Angle_t(5000000);
          break;
      }
      irrecv.resume();
    }
    time_gyro(10);
  }
}

